using System;
using System.Text.RegularExpressions;

class HyperlinksExtractor
{
	static void Main(string[] args)
	{
		string text = @"<html> This is a hyperlink: 
			<a href=""javascript:'window.close()'"">
			close the window</a><br> ... and one more link: <a 
			target=""_blank"" href=/main.aspx class='link'> <b>
			main page </b> </a>< a href = 'http://www.nakov.com'
			> <img src='logo.gif'>Nakov's home site < /a >
			<aa href=test>not a link!</a><a href hr='test'>not
			a link too!</a><href='www.devbg.org'>invalid!</a>
			</html>";

		string hrefPattern =
			@"<\s*a\s[^>]*\bhref\s*=\s*" +
			@"('(?<url>[^']*)'|""(?<url>[^""]*)""|(?<url>\S*))[^>]*>" +
			@"(?<linktext>(.|\s)*?)<\s*/a\s*>";

		Match match = Regex.Match(text, hrefPattern);
		while (match.Success)
		{
			string hyperlink = match.Value;
			hyperlink = Regex.Replace(hyperlink, @"\s+", " ");
			Console.WriteLine("hyperlink={0}", hyperlink);

			string linktext = match.Groups["linktext"].Value;
			linktext = Regex.Replace(linktext, @"\s+", " ");
			linktext = linktext.Trim();
			Console.WriteLine("linktext={0}", linktext);

			string url = match.Groups["url"].Value;
			Console.WriteLine("url={0}", url);

			Console.WriteLine();

			match = match.NextMatch();
		}
	}
}